package com.consultingwerk.plugins.smartunitlaunchconfig.delegates;

import java.io.IOException;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.debug.core.ILaunch;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.model.LaunchConfigurationDelegate;
import org.eclipse.debug.internal.ui.DebugUIPlugin;
import org.eclipse.debug.ui.ILaunchGroup;

import com.consultingwerk.plugins.common.utilities.ConsoleHelper;
import com.consultingwerk.plugins.smartunitlaunchconfig.SmartUnitAttributes;
import com.consultingwerk.plugins.smartunitlaunchconfig.utilities.SmartUnitHelper;

/**
 * Delegate for launching SmartUnit tests
 */
public class SmartUnitDelegate 
    extends LaunchConfigurationDelegate 
{
    /**
     * Launches the given configuration
     * @param configuration the configuration to launch
     * @param mode The mode to launch (run, debug,..)
     * @param launch The launch object
     * @param monitor The ProgressMonitor to use
     */
    @Override
    public void launch (ILaunchConfiguration config, 
                        String mode, 
                        ILaunch launch, 
                        IProgressMonitor monitor)
    {
        try
        {
//            DebugUIPlugin.getDefault().getLaunchConfigurationManager().getLaunchHistory("org.eclipse.debug.ui.launchGroup." + mode).addFavorite(config);
            SmartUnitHelper.run (launch, mode);
        }
        catch (CoreException | IOException e)
        {
            ConsoleHelper.printException (e);
        }
    }
}
