package com.consultingwerk.plugins.smartunitlaunchconfig.ui.views;

import java.io.File;

import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.ide.IDE;

import com.consultingwerk.plugins.common.utilities.ConsoleHelper;
import com.consultingwerk.plugins.common.utilities.FileHelper;
import com.consultingwerk.plugins.smartunitlaunchconfig.SmartUnitAttributes;

/**
 * Launches the SmartUnitView, reuses existing view if possible
 */
public class SmartUnitViewLauncher 
{
    private static SmartUnitView view = null;
    
    /**
     * Launches the SmartUnitView for the given file
     * @param filename
     */
    public static void openFile (String filename)
    {
        File file = new File (filename);
        if (  (!file.exists ())
            || !file.canWrite ())
            return;
        
        if (    view != null
            && !view.isDisposed ())
            view.openFile (filename);
        else
        {
            try 
            {
                IDE.setDefaultEditor(FileHelper.getFile(filename), SmartUnitAttributes.SmartUnitViewID);
                view = (SmartUnitView) IDE.openEditor (PlatformUI.getWorkbench ()
                                                                 .getActiveWorkbenchWindow ()
                                                                 .getActivePage (), 
                                                       new SmartUnitViewInput (filename), 
                                                       SmartUnitAttributes.SmartUnitViewID, 
                                                       true);
            } 
            catch (PartInitException e) 
            {
                ConsoleHelper.printException (e);
            }
        }
        view.setFocus();
    }
}
